#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Jan 26 11:43:21 2021

@author: arya.yazdan-panah
"""

import os
import sys
from termcolor import colored, cprint
from common3 import init_script, get_regex
from argparse import ArgumentParser, ArgumentDefaultsHelpFormatter

MSG = "Verify dicom imports and find duplicates for verification"

if __name__ == '__main__':
    usage = "usage: %prog [opts]"
    parser = ArgumentParser(description=MSG,
                            formatter_class=ArgumentDefaultsHelpFormatter)
    p0 = parser.add_argument_group("Mandatory Options")
    p0.add_argument('-s', '--subjects', dest='subjects',
                    help='Subjects list, if none choices will be provided')
    p0.add_argument('-x', '--params', dest='params',
                    help='Params file, if none choices will be provided')
    p1 = parser.add_argument_group("Advanced Options")
    p1.add_argument("-r", "--raw", dest="raw",
                    help="Raw directory, if none deduced from PROJECT_DIR")
    p1.add_argument("-d", "--dicom", dest="dicom",
                    help="Dicom dir ID/SEQ/*.dic, if none deduced from "
                    "parameters file, option -x")
    options = parser.parse_args()
    cprint(os.path.basename(sys.argv[0]), attrs=['reverse', 'bold'])
    init = init_script(options)
    params = init['params']
    dicom = init['dicom']
    raw = init['raw']
    subjects = init['subjects']
    check_file = os.path.join(init['utils'], 'CheckImport.list')
    f = open(check_file, 'w')
    f.write("# This file is automatically generated by SEPcheckImport.py\n")
# -------------------------------- Importing  ---------------------------------
    for s in subjects:
        s['extra'] = os.path.join(dicom, s['extra'])
        if not os.path.isdir(s['extra']):
            print(colored('|', 'blue', attrs=['bold']),
                  colored('|', 'green', attrs=['bold']),
                  colored('ERROR: Dicom folder not found:', 'red',
                          attrs=['bold']), s['extra'])
            continue
        s['raw'] = os.path.join(raw, s['Id'], s['Visit'])
        if not os.path.isdir(s['raw']):
            print(colored('|', 'blue', attrs=['bold']),
                  colored('|', 'green', attrs=['bold']),
                  colored('ERROR: raw folder not found:', 'red',
                          attrs=['bold']), s['Id'], s['Visit'])
            continue
        print_name = True
        for i, seq in enumerate(params):
            seqrawdir = get_regex(s['raw'], '(%s$|%s_\d)' % (seq['seqname'],
                                                             seq['seqname']),
                                  deep_search=0)
            N = len(seqrawdir)
            if N != 1:
                if print_name:
                    cprint('|', 'blue', attrs=['bold'])
                    print(colored('|', 'blue', attrs=['bold']),
                          colored('| ' + s['Id'] + ' ' + s['Visit'] + ': ',
                                  'green', attrs=['bold', 'reverse']))
                    f.write('%s,%s\n' % (s['Id'], s['Visit']))
                    print_name = False
                print(colored('|', 'blue', attrs=['bold']),
                      colored('|', 'green', attrs=['bold']),
                      colored('Checking sequence:', 'cyan',
                              attrs=['bold', 'reverse']), seq['seqname'])
                if not seqrawdir:
                    print(colored('|', 'blue', attrs=['bold']),
                          colored('|', 'green', attrs=['bold']),
                          colored('ERROR: raw folder not found for this '
                                  'sequence:', 'red', attrs=['bold']),
                          seq['seqname'])
                    continue
                if N > 1:
                    print(colored('|', 'blue', attrs=['bold']),
                          colored('|', 'green', attrs=['bold']),
                          colored('| Number of imports found for the '
                                  'sequence:', 'cyan', attrs=['bold']), N)
                    for i, fold in enumerate(seqrawdir):
                        print(colored('|', 'blue', attrs=['bold']),
                              colored('|', 'green', attrs=['bold']),
                              colored('| ' + str(i + 1) + ':', 'cyan',
                                      attrs=['bold']), fold)
    f.close()
